/*
	$Header: /home/itig/cvsroot/ext2ifs/src/close.c,v 1.6 2001/01/06 11:51:51 jn Exp $
*/

#include "ext2fs.h"

NTSTATUS
XtFSClose (
    IN PFSD_IRP_CONTEXT IrpContext
	)
{
    IN PIRP             Irp = IrpContext->Irp;

	NTSTATUS			status = STATUS_SUCCESS;
    PIO_STACK_LOCATION  IoStack;
	PFILE_OBJECT		FileObject;
	PtrXtFSVCB			Vcb;
	PtrXtFSFCB			Fcb;
	PtrXtFSCCB			Ccb;

	ASSERT(Irp);
        
    IoStack = IoGetCurrentIrpStackLocation(Irp);
	DbgPrint(("[EXT2]: Close\n"));

	ASSERT(IoStack);
	FileObject = IoStack->FileObject;

	if(IrpContext->DeviceObject == Global->DeviceObject)
	{
		DbgPrint(("[EXT2]: Close attept on driver device object\n"));
	}
	else if(FileObject->FsContext2 == NULL)
	{
		if(FileObject->FsContext == NULL)
		{
			KdPrint((DRIVER_NAME ": How can I close without a FsContext?  And what am I closing anyway?\n"));
		}
		else
		{
			ASSERT(FileObject->FsContext);
			// at the moment it must be???
			Vcb = CONTAINING_RECORD(FileObject->FsContext, XtFSVCB, CommonFCBHeader);
			ASSERT(Vcb);
			VERIFY(Vcb, VCB);

			DbgPrint(("[EXT2]: Closing driver device object\n"));
		}
	}
	else
	{
		DbgPrint(("[EXT2]: Closing file\n"));

		ASSERT(FileObject->FsContext);

		Ccb = FileObject->FsContext2;
		ASSERT(Ccb);
		VERIFY(Ccb, CCB);

		Fcb = Ccb->fcb;
		ASSERT(Fcb);
		VERIFY(Fcb, FCB);

		Vcb = Fcb->vcb;
		ASSERT(Vcb);
		VERIFY(Vcb, VCB);

		// ok, free the ccb...
		XtFSFreeCCB(Ccb);

		// see if we can free the fcb
		if(IsListEmpty(&(Fcb->NextCCB)))
		{
			DbgPrint(("[EXT2]: Freeing FCB\n"));
			XtFSFreeFCB(Fcb);
		}

	}



	Irp->IoStatus.Status = status;
	Irp->IoStatus.Information = 0;
	XtFSCompleteRequest(IrpContext, IO_NO_INCREMENT);

	return status;
}
